

/* 
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Patrick Boenzli
   co-programmer: 
*/


#include "shoot_laser.h"

#include <iostream>


using namespace std;



ShootLaser::ShootLaser () 
{
  lastShoot = null;
}


ShootLaser::~ShootLaser () {}


void ShootLaser::drawShoot() 
{

  //cout << "ShootLaser::drawShoot" << endl;
  /* now draw all the shoots (many) */
  shoot* tmpShoot = lastShoot;
  shoot* lastRef = null;
  while( tmpShoot != null )
    {
      glPushMatrix(); 
      glTranslatef(tmpShoot->xCor, tmpShoot->yCor, tmpShoot->zCor);
      tmpShoot->yCor+=tmpShoot->yInc;
      glScalef(0.1, 0.1, 0.1);
      glutWireCube(1.0);
      glPopMatrix();

      /* garbage collection: look if shoot is outside world */
      /* fix1: weak boundaries check all four sides */
      /* fix2: conditions, that a struct tree can be cut off */
      /* fix3: more efficent and nicer please */
      if (tmpShoot->yCor > 50) 
	{
	  if (lastRef != null) 
	    {
	      cout << "garbage collection" << endl;
	      lastRef->next = tmpShoot->next;
	      delete tmpShoot;
	      tmpShoot = lastRef;	  
	      lastRef = tmpShoot;
	      tmpShoot = tmpShoot->next;
	      cout << "garbage collection left" << endl;
	    }
	  else
	    {
	      cout << "garbage collecton on last el" << endl;
	      lastRef = tmpShoot->next;
	      delete tmpShoot;
	      tmpShoot = lastRef;
	      if (tmpShoot != null) {
		lastRef = tmpShoot;
		tmpShoot = tmpShoot->next;
		cout << "noch nich null" << endl;
	      }
	      else {
		lastRef = null;
		tmpShoot = null;
		lastShoot = null;
		cout << "endl null" << endl;
	      }
	      cout << "garbage collection on last el left" << endl;
	    }
	}
      else 
	{
	  lastRef = tmpShoot;
	  tmpShoot = tmpShoot->next;
	}
    }
  //cout << "ShootLaser::drawShoot - finished" << endl;
}


void ShootLaser::addShoot(shoot* sh) 
{
  sh->next = null;
  lastShoot = sh;
}

void ShootLaser::addShoot(float x, float y, float z)
{
  //cout << "ShootLaser::addShoot" << endl;
  shoot* sh = new shoot;
  sh->xCor = x; sh->yCor = y; sh->zCor = z;
  sh->xInc = 0; sh->yInc = .2; sh->zInc = 0;
  sh->next = lastShoot;
  lastShoot = sh;
}

